Liferay.Loader.define("segments-web@1.0.59/js/components/shared/ClayToggle.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/icon', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

  var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

  var _propTypes = require("frontend-js-react-web$prop-types");

  var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

  function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
      return cache;
    };return cache;
  }

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
      return { "default": obj };
    }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
      return cache.get(obj);
    }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }newObj["default"] = obj;if (cache) {
      cache.set(obj, newObj);
    }return newObj;
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }return target;
    };return _extends.apply(this, arguments);
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
      }
    }return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
    }return target;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  var ClayToggle = /*#__PURE__*/function (_Component) {
    _inherits(ClayToggle, _Component);

    function ClayToggle() {
      _classCallCheck(this, ClayToggle);

      return _possibleConstructorReturn(this, _getPrototypeOf(ClayToggle).apply(this, arguments));
    }

    _createClass(ClayToggle, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            checked = _this$props.checked,
            className = _this$props.className,
            disabled = _this$props.disabled,
            iconOff = _this$props.iconOff,
            iconOn = _this$props.iconOn,
            label = _this$props.label,
            labelLeft = _this$props.labelLeft,
            labelOff = _this$props.labelOff,
            labelOn = _this$props.labelOn,
            labelRight = _this$props.labelRight,
            name = _this$props.name,
            onChange = _this$props.onChange,
            otherProps = _objectWithoutProperties(_this$props, ["checked", "className", "disabled", "iconOff", "iconOn", "label", "labelLeft", "labelOff", "labelOn", "labelRight", "name", "onChange"]);

        var classes = (0, _classnames["default"])('toggle-switch', className);
        return _react["default"].createElement("label", _extends({
          className: classes
        }, otherProps), _react["default"].createElement("input", {
          checked: checked,
          className: "toggle-switch-check",
          disabled: disabled,
          name: name,
          onChange: onChange,
          type: "checkbox"
        }), label && _react["default"].createElement("span", {
          className: "toggle-switch-label"
        }, label), labelLeft && _react["default"].createElement("span", {
          className: "toggle-switch-text toggle-switch-text-left"
        }, labelLeft), labelRight && _react["default"].createElement("span", {
          className: "toggle-switch-text toggle-switch-text-right"
        }, labelRight), _react["default"].createElement("span", {
          "aria-hidden": "true",
          className: "toggle-switch-bar"
        }, _react["default"].createElement("span", {
          className: "toggle-switch-handle",
          "data-label-off": labelOff,
          "data-label-on": labelOn
        }, iconOff && _react["default"].createElement("span", {
          className: "button-icon button-icon-off toggle-switch-icon"
        }, _react["default"].createElement(_icon["default"], {
          symbol: iconOff
        })), iconOn && _react["default"].createElement("span", {
          className: "button-icon button-icon-on toggle-switch-icon"
        }, _react["default"].createElement(_icon["default"], {
          symbol: iconOn
        })))));
      }
    }]);

    return ClayToggle;
  }(_react.Component);

  _defineProperty(ClayToggle, "defaultProps", {
    checked: false,
    label: '',
    labelLeft: '',
    labelOff: '',
    labelOn: '',
    labelRight: ''
  });

  var _default = ClayToggle;
  exports["default"] = _default;
  //# sourceMappingURL=ClayToggle.es.js.map
});
//# sourceMappingURL=ClayToggle.es.js.map